/*
@version $Id: roles.js 1126 2011-10-03 14:39:22Z roosit $
@package Abricos
@copyright Copyright (C) 2011 Abricos All rights reserved.
@license http://www.gnu.org/copyleft/gpl.html GNU/GPL, see LICENSE.php
*/
var Component = new Brick.Component();
Component.requires = {
	mod:[{name: 'user', files: ['permission.js']}]
};
Component.entryPoint = function(){
	
	var NS = this.namespace,
		BP = Brick.Permission,
		moduleName = this.moduleName;

	NS.roles = {
		load: function(callback){
			BP.load(function(){
				NS.roles['isAdmin'] = BP.check(moduleName, '50') == 1;
				NS.roles['isWrite'] = BP.check(moduleName, '30') == 1;
				callback();
			});
		}
	};
};